NB. viewer.ijs
NB. Simple text and url viewer

require'task'
coclass'base'

VERSION=: '2.0.1'
VERSIONDATE=: '2014-07-21'
DBG=: 0

VIEW=: 0 : 0
pc view escclose;pn "Viewer";
menupop "File";
menu open "&Open file..." "Ctrl+O";
menu url "Open &url..." "Ctrl+U";
menusep;
menu save "&Save" "Ctrl+S";
menu print "&Print..." "Ctrl+P";
menusep;
menu pref "Pre&ferences...";
menusep;
menu exit "E&xit" "Ctrl+Q";
menupopz;
menupop "Edit";
menu annot "&Annotate";
menu wrap "&Wrap";
menupopz;
menupop "Help";
menu about "&About";
menupopz;
cc tools toolbar;
minwh 800 500;cc vw editm readonly flush;
)

viewtb=: 3 : 0
wd'set tools add open "Open file" "',TBP__,'folder-horizontal-open.png"'
wd'set tools add url "Open URL" "',TBP__,'globe-green.png"'
wd'set tools addsep'
wd'set tools add save "Save output file" "',TBP__,'disk.png"'
wd'set tools add print "Print output file" "',TBP__,'printer.png"'
wd'set tools addsep'
wd'set tools add pref "Preferences" "',TBP__,'gear.png"'
wd'set tools addsep'
wd'set tools add annot "Annotate" "',TBP__,'document-text-pencil.png"'
wd'set tools checkable annot'
wd'set tools addsep'
wd'set tools add about "About" "',TBP__,'question.png"'
)

view_run=: 3 : 0
IDE=: 1
showide''
sysinit''
SetDefaults''
readPref''
Title=: Data=: ''
wd'fontdef ',FFont__
wd VIEW
wd'set wrap checked; set vw wrap 1'
wd'picon "',Sdir__,'bin/icons/app.png"'
wd'set vw stylesheet *QPlainTextEdit {background-color:#eeeeee;',(font2css VFont__),'}'
wd'set vw text *',Data
TBP=: Bdir,'icons/'
viewtb''
wd 'pshow;'
Ed=: 0
WRAP=: 1
view_wrap_button''
)

close=: 3 : 0
wd'pclose'
)

view_exit_button=: view_cancel_button=: view_close=: view_cancel=: 3 : 'exit 0'

view_open_button=: 3 : 0
fn=. wd 'mb open1 "Open file" "',Ddir__,'" "" "Text files (*.txt)|*.txt|All files (*.*)|*.*"'
if. 0=#fn do. return. end.
Data=: freads fn
wd'set vw text *',Data
)

view_url_button=: 3 : 0
open_geturl_''
)

view_save_button=: 3 : 0
dout=. vw
if. 0=#dout do. return. end.
fn=. wd'mb save "Save file" "',Ddir__,'" "',Title,'.txt" "Text files (*.txt)|*.txt|All files (*.*)|*.*"'
if. 0=#fn do. return. end.
Ddir__=: >{.pathname fn
dout fwrites fn
)

view_print_button=: 3 : 0
if. 0=#vw do. return. end.
wd'defprint margin ',":MARGIN__
if. ORIENT__ do. wd'defprint orient landscape' else. wd'defprint orient portrait' end.
wd'cmd vw print'
)

view_pref_button=: open_pref_

view_annot_button=: 3 : 0
if. Ed do.
  wd'set vw readonly 1; set annot checked 0;set tools checked annot 0'
  wd'set vw stylesheet *QPlainTextEdit {background-color:#eeeeee;',(font2css VFont__),'}'
  Ed=: 0
else.
  wd'set vw readonly 0; set annot checked 1; set tools checked annot 1'
  wd'set vw stylesheet *QPlainTextEdit {background-color:#ffffff;',(font2css VFont__),'}'
  Ed=: 1
end.  
)

view_wrap_button=: 3 : 0
if. WRAP do.
  WRAP=: 0
  wd'set wrap checked 0'
  wd'set vw wrap 0'
else.
  WRAP=: 1
  wd'set wrap checked 1'
  wd'set vw wrap 1'
end.
)

view_about_button=: open_about_

showide=: 3 : 0
if. IDE do.
  IDE=: 0
  wd'ide hide'
else.
  IDE=: 1
  wd'ide show'
  wd'psel view;pactive'
end.
empty''
)

view_wctrl_fkey=: showide

dbg=: 3 : 0
DBG=: 1
select. UNAME
  case. 'Win' do.
    b=. 'c:\Utility\Viewer\bin'
    1!:44 b
    p=. GetEnv'path'
    if. -.(';' taketo p) -: b do. SetEnv'PATH';(b,';',p) end.
  case. 'Darwin' do.
    b=. '/Users/drinkwater/Viewer/bin'
    1!:44 b
    p=. 2!:5'PATH'
    if. -.(':' taketo p) -: b do. SetEnv'PATH';(b,':',p) end.
  case. 'Linux' do.
    1!:44'/home/drinkwater/viewer/bin'
end.
cocurrent'base'
view_run''
)

