NB. pref.ijs
NB. form for preferences

require 'general/misc/validate'
coclass 'pref'

SetDefaults=: 3 : 0
os=. (<UNAME) inx 'Win';'Darwin';'Linux'
FFont__=: ,>os{ (,>(6<".wd'qosver'){'"Arial" 10';'"Segoe UI Semibold" 10');'"Lucida Grande" 12';'"Sans" 10'
VFont__=: ,>os{ (,>(5.2<".wd'qosver'){'"Courier New" 10';'Consolas 12');'"Monaco" 10';'"Monospaced" 10'
Ddir__=: gethomedir__''
ORIENT__=: 0
MARGIN__=: 0
''
)

PREF=: 0 : 0
pc pref dialog escclose nosize;pn "Viewer Preferences";
bin vh;
minwh 96 12;cc lbff static right;cn "Form font";
minwh 272 12;cc ffe edit readonly;
cc ffchange button;cn "Change";
bin z;
bin vh;
minwh 96 12;cc lbvf static right;cn "Report font";
minwh 272 12;cc vfe edit readonly;
cc vfchange button;cn "Change";
bin z;
bin vh;
minwh 80 12;cc lbmar static right;cn "Margin (mm)";
cc mg edit;set mg wh 60 _1;
groupbox Orientation;
bin h;
cc orbt0 radiobutton;cn "Portrait";
cc orbt1 radiobutton group;cn "Landscape";
bin z;
groupboxend;
bin z;
bin h;
cc reset button;cn "Reset def.";
bin s2;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";

pas 10 10;
pcenter;
)

open=: 3 : 0
wd PREF
FFont=: FFont__
VFont=: VFont__
MARGIN=: MARGIN__
ORIENT=: ORIENT__
wd'set ffe stylesheet *background-color:#eeeeee'
wd'set vfe stylesheet *background-color:#eeeeee'
wd'set ffe text *',FFont
wd'set vfe text *',VFont
wd'set mg text *',":MARGIN
wd'set orbt',(":ORIENT),' 1'
wd'pshow;'
)

close=: 3 : 0
wd 'pclose'
)

pref_cancel_button=: mspref_cancel=: close

pref_ffchange_button=: 3 : 0
ff =. mbfont FFont
if. 0 = #ff do.
   return.
end.
FFont=: ff
wd 'set ffe text *',ff
)

pref_vfchange_button=: 3 : 0
vf =. mbfont VFont
if. 0 = #vf do.
   return.
end.
VFont=: vf
wd 'set vfe text *',vf
)

pref_reset_button=: 3 : 0
SetDefaults''
writePref Profdir__
FFont=: FFont__
VFont=: VFont__
MARGIN=: MARGIN__
ORIENT=: ORIENT__
wd'set ffe stylesheet *background-color:#eeeeee'
wd'set vfe stylesheet *background-color:#eeeeee'
wd'set ffe text *',FFont
wd'set vfe text *',VFont
wd'set mg text *',":MARGIN
wd'set orbt',(":ORIENT),' 1'
wd'pshow;'
)


pref_ok_button=: 3 : 0
mgn=. __ ". mg
if. -. isnonneg mgn do.
  mbError'Value error';'Margin must be greater than or equal to 0.'
  return.
end.
FFont=: ffe
VFont=: vfe
ORIENT=: ". orbt1
MARGIN=: mgn
close''
FFont__=: FFont
if. -. VFont -: VFont__ do.
  wd'psel view'
  wd'set vw stylesheet *background-color:#eeeeee;',font2css VFont
end.
VFont__=: VFont
MARGIN__=: MARGIN
ORIENT__=: ORIENT
writePref''
)


readPref=: 3 : 0
NB. run ini script
s=. freads Profdir__,'viewer.ini'
try. (0!:0 s)
catch.
  mbError'File error';'Viewer ini file is corrupt or missing, using defaults'
  SetDefaults''
  writePref''
end.
)

writePref=: 3 : 0
path=. Profdir__,'viewer.ini'
q=. ''''
d=. 'NB. viewer.ini',LF,'NB. Automatically generated, do not edit',LF
d=. d,'FFont__=: ',q,FFont__,q,LF
d=. d,'VFont__=: ',q,VFont__,q,LF
d=. d,'MARGIN__=: ',(":MARGIN__),LF
d=. d,'ORIENT__=: ',(":ORIENT__),LF
d=. d,'Ddir__=: ',q,Ddir__,q,LF
d fwrites path
)


writePref__=: writePref_pref_
readPref__=: readPref_pref_
SetDefaults__=: SetDefaults_pref_
