NB. about.ijs
NB. about dialog


require'gl2'
require' graphics/bmp'

coclass 'about'
coinsert'jgl2'

ABOUT=: 0 : 0
pc about escclose dialog nosize;pn "About Viewer";
bin vh;
cc l1 static sunken center;set l1 wh 280 112; 
cc pic image;
bin zh;
cc l2 static sunken;
bin z;
bin h s2;
cc ok button;cn "&OK";
)

vinfo=: 0 : 0
A sample standalone application
)

cinfo=: 0 : 0
Copyright (c) 2014
)

open=: 3 : 0
wd ABOUT
wd 'set l1 text ','Viewer ',VERSION__,' (',VERSIONDATE__,')',LF,vinfo
wd 'set l2 text ',cinfo
wd'set pic image *',Bdir__,'toucan.bmp'
wd 'pshow;'
empty''
)



about_close=: 3 : 'wd''pclose'''

about_ok_button=: about_cancel=: about_close
NB. geturl.ijs

require'web/gethttp'
coclass'geturl'

LASTURL=: 'http://'

GETURL=: 0 : 0
pc geturl escclose dialog owner nosize;pn "Retrieve URL";
bin vh;
minwh 40 22;cc urlsrc static right;cn "URL";
minwh 400 24;cc src edit;
bin z;
bin h s2;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";
pcenter;
)

open=: 3 : 0
wd GETURL
wd'set src text *',LASTURL
wd'pshow'
)

geturl_ok_button=: 3 : 0
res=. src
if. res -: 'http://' do. res=.'' end.
wd'pclose'
if. 0<#res do.
  LASTURL=: res
  dat=. gethttp LASTURL
  wd'psel view; set vw text *',dat
end.
)

geturl_src_button=: geturl_ok_button

close=: 3 : 0
wd'pclose'
)

geturl_close=: geturl_cancel_button=: close
NB. pref.ijs
NB. form for preferences

require 'general/misc/validate'
coclass 'pref'

SetDefaults=: 3 : 0
os=. (<UNAME) inx 'Win';'Darwin';'Linux'
FFont__=: ,>os{ (,>(6<".wd'qosver'){'"Arial" 10';'"Segoe UI Semibold" 10');'"Lucida Grande" 12';'"Sans" 10'
VFont__=: ,>os{ (,>(5.2<".wd'qosver'){'"Courier New" 10';'Consolas 12');'"Monaco" 10';'"Monospaced" 10'
Ddir__=: gethomedir__''
ORIENT__=: 0
MARGIN__=: 0
''
)

PREF=: 0 : 0
pc pref dialog escclose nosize;pn "Viewer Preferences";
bin vh;
minwh 96 12;cc lbff static right;cn "Form font";
minwh 272 12;cc ffe edit readonly;
cc ffchange button;cn "Change";
bin z;
bin vh;
minwh 96 12;cc lbvf static right;cn "Report font";
minwh 272 12;cc vfe edit readonly;
cc vfchange button;cn "Change";
bin z;
bin vh;
minwh 80 12;cc lbmar static right;cn "Margin (mm)";
cc mg edit;set mg wh 60 _1;
groupbox Orientation;
bin h;
cc orbt0 radiobutton;cn "Portrait";
cc orbt1 radiobutton group;cn "Landscape";
bin z;
groupboxend;
bin z;
bin h;
cc reset button;cn "Reset def.";
bin s2;
cc ok button;cn "&OK";
cc cancel button;cn "&Cancel";

pas 10 10;
pcenter;
)

open=: 3 : 0
wd PREF
FFont=: FFont__
VFont=: VFont__
MARGIN=: MARGIN__
ORIENT=: ORIENT__
wd'set ffe stylesheet *background-color:#eeeeee'
wd'set vfe stylesheet *background-color:#eeeeee'
wd'set ffe text *',FFont
wd'set vfe text *',VFont
wd'set mg text *',":MARGIN
wd'set orbt',(":ORIENT),' 1'
wd'pshow;'
)

close=: 3 : 0
wd 'pclose'
)

pref_cancel_button=: mspref_cancel=: close

pref_ffchange_button=: 3 : 0
ff =. mbfont FFont
if. 0 = #ff do.
   return.
end.
FFont=: ff
wd 'set ffe text *',ff
)

pref_vfchange_button=: 3 : 0
vf =. mbfont VFont
if. 0 = #vf do.
   return.
end.
VFont=: vf
wd 'set vfe text *',vf
)

pref_reset_button=: 3 : 0
SetDefaults''
writePref Profdir__
FFont=: FFont__
VFont=: VFont__
MARGIN=: MARGIN__
ORIENT=: ORIENT__
wd'set ffe stylesheet *background-color:#eeeeee'
wd'set vfe stylesheet *background-color:#eeeeee'
wd'set ffe text *',FFont
wd'set vfe text *',VFont
wd'set mg text *',":MARGIN
wd'set orbt',(":ORIENT),' 1'
wd'pshow;'
)


pref_ok_button=: 3 : 0
mgn=. __ ". mg
if. -. isnonneg mgn do.
  mbError'Value error';'Margin must be greater than or equal to 0.'
  return.
end.
FFont=: ffe
VFont=: vfe
ORIENT=: ". orbt1
MARGIN=: mgn
close''
FFont__=: FFont
if. -. VFont -: VFont__ do.
  wd'psel view'
  wd'set vw stylesheet *background-color:#eeeeee;',font2css VFont
end.
VFont__=: VFont
MARGIN__=: MARGIN
ORIENT__=: ORIENT
writePref''
)


readPref=: 3 : 0
NB. run ini script
s=. freads Profdir__,'viewer.ini'
try. (0!:0 s)
catch.
  mbError'File error';'Viewer ini file is corrupt or missing, using defaults'
  SetDefaults''
  writePref''
end.
)

writePref=: 3 : 0
path=. Profdir__,'viewer.ini'
q=. ''''
d=. 'NB. viewer.ini',LF,'NB. Automatically generated, do not edit',LF
d=. d,'FFont__=: ',q,FFont__,q,LF
d=. d,'VFont__=: ',q,VFont__,q,LF
d=. d,'MARGIN__=: ',(":MARGIN__),LF
d=. d,'ORIENT__=: ',(":ORIENT__),LF
d=. d,'Ddir__=: ',q,Ddir__,q,LF
d fwrites path
)


writePref__=: writePref_pref_
readPref__=: readPref_pref_
SetDefaults__=: SetDefaults_pref_
NB. req.ijs
NB. utility functions

coclass 'z'

NB. boxfont - boxes font name
boxfont=: 3 : 0
font=. ' ',y
b=. (font=' ') > ~:/\font='"'
a: -.~ b <;._1 font
)

NB. font2css
NB. convert mb font result to css
font2css=: 3 : 0
'font sz wt'=. 3{.(boxfont y),<''
r=. 'font: ',sz,'pt ',font,'; '
if. 0<#wt do.
  r=. r,'font-weight: ',wt,';'
end.
r
)

GetCWD=: (,&'/')@jpath@(1!:43)
SetCWD=: 1!:44

NB. inx index of x in y
inx =: e.~&, # i.@#@]

ispos =: 3 : 0
-. 1 e. 0>:y
)

isnonneg =: 3 : 0
-. 1 e. 0 > y
)


NB. mbAsk - Yes/No/Cancel msgbox
NB. y is dialog title;error message
mbAsk=: 3 : 0
'title message'=. y
wd 'mb query mb_yes mb_no mb_cancel "',title,'" "',message,'"'
)

NB. mbError - Error msgbox
NB. y is dialog title;error message
mbError=: 3 : 0
'title message'=. y
wd 'mb warn "',title,'" "',message,'"'
)

NB. mbInfo - Info msgbox
mbInfo=: 3 : 0
'title message'=. y
wd 'mb info "',title,'" "',message,'"'
)

NB. mbQuery - Yes/No msgbox
NB. y is dialog title;error message
mbQuery=: 3 : 0
'title message'=. y
wd 'mb query mb_yes mb_no "',title,'" "',message,'"'
)

mbfont=: 3 : 0
NB. calls font chooser with y as starting point
if. #y do.
y=. boxfont y
y=. ({.y), tolower each }.y
y=. y -. 'ansi';'oem';'default'
y=. }: ; ,&' ' &.> y
end.
wd 'mb font ',y
)

parentdir=: 3 : 0
,>{. pathname }: y
)

pathname=: ({. ; }.)~ (0: i.~ +./\.@(=&'/'))
NB. sysdep.ijs
NB. system dependent functions

coclass'base'

SetEnvironmentVariable=: 'kernel32 SetEnvironmentVariableA i *c *c' & cd
GetEnvironmentVariable=: 'kernel32 GetEnvironmentVariableA i *c *c i' & cd 

GetEnv=: 3 : 0
if. IFWIN do.
  r=. GetEnvironmentVariable y;(2048#' ');2048
  r=. (>{.r){.>2{r
else.
  r=. 2!:5 y
end.
r
)

SetEnv=: 3 : 0 
if. IFWIN do.
  r=. SetEnvironmentVariable y
  >0{r
  return.
end.
if. UNAME -: 'Darwin' do.
  'sv new'=. y
  f=. 'libc.dylib setenv x *c *c x'&cd
  r=. f y,<1
end.
)

sysinit=: 3 : 0
NB. sets system dependent global variables
Bdir__=: GetCWD''
Sdir__=: parentdir Bdir__
Homedir__=: gethomedir''
Profdir__=: getprofdir''
if. 0=# dir }:Profdir__ do. 1!:5<}:Profdir__ end.
if. UNAME-:'Win' do. HTTPCMD_wgethttp_=: '"',Bdir__,'curl"' end.
)

getprofdir=: 3 : 0
if. IFWIN do.
  r=. jpath (GetEnv'appdata'),'\viewer\'
else.
  r=. (GetEnv'HOME'),'/.viewer/'
end.
)

gethomedir=: 3 : 0
if. IFWIN do.
  r=. jpath (GetEnv'homedrive'),(GetEnv'homepath'),'\'
else.
  r=. (GetEnv'HOME'),'/'
end.
r
)

spawn_z_=: spawn_jtask_
NB. viewer.ijs
NB. Simple text and url viewer

require'task'
coclass'base'

VERSION=: '2.0.1'
VERSIONDATE=: '2014-07-21'
DBG=: 0

VIEW=: 0 : 0
pc view escclose;pn "Viewer";
menupop "File";
menu open "&Open file..." "Ctrl+O";
menu url "Open &url..." "Ctrl+U";
menusep;
menu save "&Save" "Ctrl+S";
menu print "&Print..." "Ctrl+P";
menusep;
menu pref "Pre&ferences...";
menusep;
menu exit "E&xit" "Ctrl+Q";
menupopz;
menupop "Edit";
menu annot "&Annotate";
menu wrap "&Wrap";
menupopz;
menupop "Help";
menu about "&About";
menupopz;
cc tools toolbar;
minwh 800 500;cc vw editm readonly flush;
)

viewtb=: 3 : 0
wd'set tools add open "Open file" "',TBP__,'folder-horizontal-open.png"'
wd'set tools add url "Open URL" "',TBP__,'globe-green.png"'
wd'set tools addsep'
wd'set tools add save "Save output file" "',TBP__,'disk.png"'
wd'set tools add print "Print output file" "',TBP__,'printer.png"'
wd'set tools addsep'
wd'set tools add pref "Preferences" "',TBP__,'gear.png"'
wd'set tools addsep'
wd'set tools add annot "Annotate" "',TBP__,'document-text-pencil.png"'
wd'set tools checkable annot'
wd'set tools addsep'
wd'set tools add about "About" "',TBP__,'question.png"'
)

view_run=: 3 : 0
IDE=: 1
showide''
sysinit''
SetDefaults''
readPref''
Title=: Data=: ''
wd'fontdef ',FFont__
wd VIEW
wd'set wrap checked; set vw wrap 1'
wd'picon "',Sdir__,'bin/icons/app.png"'
wd'set vw stylesheet *QPlainTextEdit {background-color:#eeeeee;',(font2css VFont__),'}'
wd'set vw text *',Data
TBP=: Bdir,'icons/'
viewtb''
wd 'pshow;'
Ed=: 0
WRAP=: 1
view_wrap_button''
)

close=: 3 : 0
wd'pclose'
)

view_exit_button=: view_cancel_button=: view_close=: view_cancel=: 3 : 'exit 0'

view_open_button=: 3 : 0
fn=. wd 'mb open1 "Open file" "',Ddir__,'" "" "Text files (*.txt)|*.txt|All files (*.*)|*.*"'
if. 0=#fn do. return. end.
Data=: freads fn
wd'set vw text *',Data
)

view_url_button=: 3 : 0
open_geturl_''
)

view_save_button=: 3 : 0
dout=. vw
if. 0=#dout do. return. end.
fn=. wd'mb save "Save file" "',Ddir__,'" "',Title,'.txt" "Text files (*.txt)|*.txt|All files (*.*)|*.*"'
if. 0=#fn do. return. end.
Ddir__=: >{.pathname fn
dout fwrites fn
)

view_print_button=: 3 : 0
if. 0=#vw do. return. end.
wd'defprint margin ',":MARGIN__
if. ORIENT__ do. wd'defprint orient landscape' else. wd'defprint orient portrait' end.
wd'cmd vw print'
)

view_pref_button=: open_pref_

view_annot_button=: 3 : 0
if. Ed do.
  wd'set vw readonly 1; set annot checked 0;set tools checked annot 0'
  wd'set vw stylesheet *QPlainTextEdit {background-color:#eeeeee;',(font2css VFont__),'}'
  Ed=: 0
else.
  wd'set vw readonly 0; set annot checked 1; set tools checked annot 1'
  wd'set vw stylesheet *QPlainTextEdit {background-color:#ffffff;',(font2css VFont__),'}'
  Ed=: 1
end.  
)

view_wrap_button=: 3 : 0
if. WRAP do.
  WRAP=: 0
  wd'set wrap checked 0'
  wd'set vw wrap 0'
else.
  WRAP=: 1
  wd'set wrap checked 1'
  wd'set vw wrap 1'
end.
)

view_about_button=: open_about_

showide=: 3 : 0
if. IDE do.
  IDE=: 0
  wd'ide hide'
else.
  IDE=: 1
  wd'ide show'
  wd'psel view;pactive'
end.
empty''
)

view_wctrl_fkey=: showide

dbg=: 3 : 0
DBG=: 1
select. UNAME
  case. 'Win' do.
    b=. 'c:\Utility\Viewer\bin'
    1!:44 b
    p=. GetEnv'path'
    if. -.(';' taketo p) -: b do. SetEnv'PATH';(b,';',p) end.
  case. 'Darwin' do.
    b=. '/Users/drinkwater/Viewer/bin'
    1!:44 b
    p=. 2!:5'PATH'
    if. -.(':' taketo p) -: b do. SetEnv'PATH';(b,':',p) end.
  case. 'Linux' do.
    1!:44'/home/drinkwater/viewer/bin'
end.
cocurrent'base'
view_run''
)

